# mypy-boto3-kinesis

[![PyPI - mypy-boto3-kinesis](https://img.shields.io/pypi/v/mypy-boto3-kinesis.svg?color=blue)](https://pypi.org/project/mypy-boto3-kinesis)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-kinesis.svg?color=blue)](https://pypi.org/project/mypy-boto3-kinesis)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-kinesis](#mypy-boto3-kinesis)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)

Type annotations for
[boto3.Kinesis 1.14.0](https://boto3.amazonaws.com/v1/documentation/api/1.14.0/reference/services/kinesis.html#Kinesis) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.4](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Kinesis` service.

```bash
python -m pip install boto3-stubs[kinesis]
```

Use `boto3` with `mypy_boto3_kinesis` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_kinesis import KinesisClient

# Now mypy can check if your code is valid.
client: KinesisClient = boto3.client("kinesis")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: KinesisClient = session.client("kinesis")



# Waiters are also supported

import mypy_boto3_kinesis.waiter as kinesis_waiters

stream_exists_waiter: kinesis_waiters.StreamExistsWaiter = client.get_waiter("stream_exists")
stream_not_exists_waiter: kinesis_waiters.StreamNotExistsWaiter = client.get_waiter("stream_not_exists")


# Annotated paginators are included as well

import mypy_boto3_kinesis.paginator as kinesis_paginators

describe_stream_paginator: kinesis_paginators.DescribeStreamPaginator = client.get_paginator("describe_stream")
list_shards_paginator: kinesis_paginators.ListShardsPaginator = client.get_paginator("list_shards")
list_stream_consumers_paginator: kinesis_paginators.ListStreamConsumersPaginator = client.get_paginator("list_stream_consumers")
list_streams_paginator: kinesis_paginators.ListStreamsPaginator = client.get_paginator("list_streams")
```

## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_kinesis` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python
import boto3

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("kinesis")

session_client = boto3.Session().client("kinesis")
```